maptog = 0;

function PS_Minimap_IconFrame_OnClick(button)

  if (not PS_Minimap_IconFrame:IsVisible()) then
    return;
  end
  if ( button == "RightButton" ) then
    if maptog == 1 then
      PS_OptionsForm:Hide()
      maptog = 0;
    end
    local menu = getglobal("PS_MinimapMenu");
    menu.point = "TOPRIGHT";
    menu.relativePoint = "CENTER";
    ToggleDropDownMenu(1, nil, menu, "PS_Minimap_IconFrame", 0, 0);
  else
    if maptog == 0 then
      PS_OptionsForm_InitializeOptions();
      PS_OptionsForm:Show()
      maptog = 1;
    else
      maptog = 0;
      PS_OptionsForm:Hide()
    end
  end
end

local function move_icon()

  PS_Minimap_IconFrame:SetPoint("TOPLEFT", "Minimap", "TOPLEFT", 52-(80*cos(PSvars.MinimapIconPos or 45)),(80*sin(PSvars.MinimapIconPos or 45))-52)
end

function PS_Minimap_IconFrame_OnEvent(arg1, arg2)

  if (event=="VARIABLES_LOADED") then
    PS_Minimap_RefreshMinimap();
    move_icon();
  end
end

function PS_Minimap_RefreshMinimap()

  if (PSvars.MiniIcon) then
    PS_Minimap_IconFrame:Show();
  else
    PS_Minimap_IconFrame:Hide();
  end
end


function PS_Minimap_IconDraggingFrame_OnUpdate(arg1)

  local xpos,ypos = GetCursorPosition()
  local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()
  xpos = xmin-xpos/Minimap:GetEffectiveScale()+70
  ypos = ypos/Minimap:GetEffectiveScale()-ymin-70
  PSvars.MinimapIconPos = math.deg(math.atan2(ypos,xpos))
  move_icon()
end

function PS_MinimapMenu_Initialize()

  PS_mapsend = 1;
  PS_LoadSavedVariables();
  local store = false;
  local announce = false;
  local color = false;
  local popup = false;
  local ping = false;
  local time = false;
  local addon = false;
  local bgcheck = true;
  local scale = false;
  if PSvars.Addons == "BG" then
    bgcheck = false;
  end
  if PSvars.tracker then
    getglobal("DropDownList1"):SetScale(.6);
  else
    getglobal("DropDownList1"):SetScale(.75);
  end
  --Title
  local info = {};
  info.text = "          "..PS_PS.." v1.17";
  info.notClickable = 1;
  info.isTitle = 1;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = " "
  info.notClickable = 1;
  info.notCheckable = 1;
  UIDropDownMenu_AddButton(info, 1);
  -- Minimap Icon
  local info = {};
  info.text = PS_TMI;
  info.checked = PSvars.MiniIcon
  info.func = function() PS_ToggleMinimapButton(); end;
  UIDropDownMenu_AddButton(info, 1);
  -- Sentry Mode
  local info = {};
  info.text = PS_SM;
  info.checked = PSvars.SentryMode
  info.func = function() PSvars.SentryMode = not PSvars.SentryMode; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  -- Sentry Neutral City check
  local info = {};
  info.text = PS_SNC;
  info.checked = PSvars.SentryChk
  info.func = function() PSvars.SentryChk = not PSvars.SentryChk; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  -- Sentry Mode Sounds
  local info = {};
  info.text = PS_SS;
  info.checked = PSvars.SentrySound
  info.func = function() PSvars.SentrySound = not PSvars.SentrySound; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  -- Death Detection
  local info = {};
  info.text = PS_DD;
  info.checked = PSvars.DeathDetect
  info.func = function() PSvars.DeathDetect = not PSvars.DeathDetect; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  -- BG Mouse-Over
  if PSvars.tracker then
    local info = {};
    info.text = PS_BGMOM;
    info.checked = PSvars.BGMode
    info.func = function() PSvars.BGMode = not PSvars.BGMode; end;
    UIDropDownMenu_AddButton(info, 1);
  end
  local info = {};
  info.text = " "
  info.notClickable = 1;
  info.notCheckable = 1;
  UIDropDownMenu_AddButton(info, 1);
   -- Addon Mode
  local info = {};
  info.text = PS_PSAS;
  info.notClickable = 1;
  info.isTitle = 1;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_AUPS;
  if PSvars.Addons == "ON" then
    addon = true;
  end
  info.checked = addon
  info.func = function() PSvars.Addons = "ON"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_PSD;
  addon = false;
  if PSvars.Addons == "OFF" then
    addon = true;
  end
  info.checked = addon
  info.func = function() PSvars.Addons = "OFF"; PS_Clear_Popup(); PS_thelist = ""; PSvars.list = {}; PS_TraceFrame(PS_DISABLED); end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_OUPSB;
  addon = false;
  if PSvars.Addons == "BG" then
    addon = true;
  end
  info.checked = addon
  info.func = function() PSvars.Addons = "BG"; if ((not PS_bgmode) and bgcheck) then PS_Clear_Popup(); PS_thelist = ""; PSvars.list = {}; end; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = " "
  info.notClickable = 1;
  info.notCheckable = 1;
  UIDropDownMenu_AddButton(info, 1);
  local track = false;
  -- Tracking Filter
  local info = {};
  info.text = PS_TS;
  info.notClickable = 1;
  info.isTitle = 1;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_ALL;
  if PSvars.tracking == "ALL" then
    track = true;
  end
  info.checked = track
  info.func = function() PSvars.tracking = "ALL"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_ALLEN;
  track = false;
  if PSvars.tracking == "ENEMIES" then
    track = true;
  end
  info.checked = track
  info.func = function() PS_Clear_Popup(); PSvars.tracking = "ENEMIES"; PS_addpop = 0; local thelist = PS_thelist; PS_thelist = ""; PS_KeepDamage(thelist); PS_Process_Tooltip(thelist); end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_ALLP;
  track = false;
  if PSvars.tracking == "ALL PLAYERS" then
    track = true;
  end
  info.checked = track
  info.func = function() PS_Clear_Popup(); PSvars.tracking = "ALL PLAYERS"; PS_addpop = 0; local thelist = PS_thelist; PS_thelist = ""; PS_KeepDamage(thelist); PS_Process_Tooltip(thelist); end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_ENP;
  track = false;
  if PSvars.tracking == "ENEMY PLAYERS" then
    track = true;
  end
  info.checked = track
  info.func = function() PS_Clear_Popup(); PSvars.tracking = "ENEMY PLAYERS"; PS_addpop = 0; local thelist = PS_thelist; PS_thelist = ""; PS_KeepDamage(thelist); PS_Process_Tooltip(thelist); end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = " "
  info.notClickable = 1;
  info.notCheckable = 1;
  UIDropDownMenu_AddButton(info, 1);
  -- Popup Draw Options
  local info = {};
  info.text = PS_PDS;
  info.notClickable = 1;
  info.isTitle = 1;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_TTB;
  if PSvars.PopupMode == "DOWNWARD" then
    popup = true;
  end
  info.checked = popup
  info.func = function() PS_Clear_Popup(); PSvars.PopupMode = "DOWNWARD"; PS_dim = 1; PS_Process_Tooltip(PS_thelist); end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_BTT;
  popup = false;
  if PSvars.PopupMode == "UPWARD" then
    popup = true;
  end
  info.checked = popup
  info.func = function() PS_Clear_Popup(); PSvars.PopupMode = "UPWARD"; PS_dim = 1; PS_Process_Tooltip(PS_thelist); end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_RST;
  popup = false;
  info.checked = popup
  info.func = function() PS_PopupDOWNWARD:ClearAllPoints(); PS_PopupUPWARD:ClearAllPoints(); PS_PopupDOWNWARD:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", 300, 300); PS_PopupUPWARD:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", 300, 300); PS_PopupComDOWNWARD:ClearAllPoints(); PS_PopupComUPWARD:ClearAllPoints(); PS_PopupComDOWNWARD:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", 300, 300); PS_PopupComUPWARD:SetPoint("TOPLEFT", "UIParent", "BOTTOMLEFT", 300, 300); end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = " "
  info.notClickable = 1;
  info.notCheckable = 1;
  UIDropDownMenu_AddButton(info, 1);
  -- Popup Scaling
  local info = {};
  info.text = PS_PSS;
  info.notClickable = 1;
  info.isTitle = 1;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_SMALL;
  if PSvars.scale == .7 then
    scale = true;
  end
  info.checked = scale
  info.func = function() PS_Clear_Popup(); PSvars.scale = .7; PS_addpop = 0; PS_dim = 1; PS_Process_Tooltip(PS_thelist); end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_MEDIUM;
  scale = false;
  if PSvars.scale == .85 then
    scale = true;
  end
  info.checked = scale
  info.func = function() PS_Clear_Popup(); PSvars.scale = .85; PS_addpop = 0; PS_dim = 1; PS_Process_Tooltip(PS_thelist); end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_LARGE;
  scale = false;
  if PSvars.scale == 1 then
    scale = true;
  end
  info.checked = scale
  info.func = function() PS_Clear_Popup(); PSvars.scale = 1; PS_addpop = 0; PS_dim = 1; PS_Process_Tooltip(PS_thelist); end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = " "
  info.notClickable = 1;
  info.notCheckable = 1;
  UIDropDownMenu_AddButton(info, 1);
  -- Popup Clear Timing
  local info = {};
  info.text = PS_PCT;
  info.notClickable = 1;
  info.isTitle = 1;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_SEC;
  if PSvars.SetTime == 30 then
    time = true;
  end
  info.checked = time
  info.func = function() PSvars.SetTime = 30; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_MIN;
  time = false;
  if PSvars.SetTime == 60 then
    time = true;
  end
  info.checked = time
  info.func = function() PSvars.SetTime = 60; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_3MIN;
  time = false;
  if PSvars.SetTime == 180 then
    time = true;
  end
  info.checked = time
  info.func = function() PSvars.SetTime = 180; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_5MIN;
  time = false;
  if PSvars.SetTime == 300 then
    time = true;
  end
  info.checked = time
  info.func = function() PSvars.SetTime = 300; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_OFFMC;
  time = false;
  if PSvars.SetTime == 9999 then
    time = true;
  end
  info.checked = time
  info.func = function() PSvars.SetTime = 9999; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = " "
  info.notClickable = 1;
  info.notCheckable = 1;
  UIDropDownMenu_AddButton(info, 1);
  -- Target Storing
  local info = {};
  info.text = PS_TSS;
  info.notClickable = 1;
  info.isTitle = 1;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_SE;
  if PSvars.storage == "ALL" then
    store = true;
  end
  info.checked = store
  info.func = function() PSvars.storage = "ALL"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_SPO;
  store = false;
  if PSvars.storage == "PLAYERS" then
    store = true;
  end
  info.checked = store
  info.func = function() PSvars.storage = "PLAYERS"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_SNO;
  store = false;
  if PSvars.storage == "NPC" then
    store = true;
  end
  info.checked = store
  info.func = function() PSvars.storage = "NPC"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_SNOTH;
  store = false;
  if PSvars.storage == "NONE" then
    store = true;
  end
  info.checked = store
  info.func = function() PSvars.storage = "NONE"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = " "
  info.notClickable = 1;
  info.notCheckable = 1;
  UIDropDownMenu_AddButton(info, 1);
  -- Announce Mode
  local info = {};
  info.text = PS_TAS;
  info.notClickable = 1;
  info.isTitle = 1;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_AUTO;
  if PSvars.announce == "AUTO" then
    announce = true;
  end
  info.checked = announce
  info.func = function() PSvars.announce = "AUTO"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_SELF;
  announce = false;
  if PSvars.announce == "SELF" then
    announce = true;
  end
  info.checked = announce
  info.func = function() PSvars.announce = "SELF"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_SAY;
  announce = false;
  if PSvars.announce == "SAY" then
    announce = true;
  end
  info.checked = announce
  info.func = function() PSvars.announce = "SAY"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_PARTY;
  announce = false;
  if PSvars.announce == "PARTY" then
    announce = true;
  end
  info.checked = announce
  info.func = function() PSvars.announce = "PARTY"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_RAID;
  announce = false;
  if PSvars.announce == "RAID" then
    announce = true;
  end
  info.checked = announce
  info.func = function() PSvars.announce = "RAID"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_YELL;
  announce = false;
  if PSvars.announce == "YELL" then
    announce = true;
  end
  info.checked = announce
  info.func = function() PSvars.announce = "YELL"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_LD;
  announce = false;
  if PSvars.announce == "LOCALDEFENSE" then
    announce = true;
  end
  info.checked = announce
  info.func = function() PSvars.announce = "LOCALDEFENSE"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = PS_AOFF;
  announce = false;
  if PSvars.announce == "OFF" then
    announce = true;
  end
  info.checked = announce
  info.func = function() PSvars.announce = "OFF"; end;
  UIDropDownMenu_AddButton(info, 1);
  local info = {};
  info.text = " "
  info.notClickable = 1;
  info.notCheckable = 1;
  UIDropDownMenu_AddButton(info, 1);
  -- PingMode Settings
  if PSvars.tracker then
    local info = {};
    info.text = PS_MPS;
    info.notClickable = 1;
    info.isTitle = 1;
    UIDropDownMenu_AddButton(info, 1);
    local info = {};
    info.text = PS_PON;
    if PSvars.PingMode == "DEFAULT" then
      ping = true;
    end
    info.checked = ping
    info.func = function() PSvars.PingMode = "DEFAULT"; end;
    UIDropDownMenu_AddButton(info, 1);
    local info = {};
    info.text = PS_PIBG;
    ping = false;
    if PSvars.PingMode == "INSIDE BG" then
      ping = true;
    end
    info.checked = ping
    info.func = function() PSvars.PingMode = "INSIDE BG"; end;
    UIDropDownMenu_AddButton(info, 1);
    local info = {};
    info.text = PS_POBG;
    ping = false;
    if PSvars.PingMode == "OUTSIDE BG" then
      ping = true;
    end
    info.checked = ping
    info.func = function() PSvars.PingMode = "OUTSIDE BG"; end;
    UIDropDownMenu_AddButton(info, 1);
    local info = {};
    info.text = PS_POFF;
    ping = false;
    if PSvars.PingMode == "OFF" then
      ping = true;
    end
    info.checked = ping
    info.func = function() PSvars.PingMode = "OFF"; end;
    UIDropDownMenu_AddButton(info, 1);
    local info = {};
    info.text = " "
    info.notClickable = 1;
    info.notCheckable = 1;
    UIDropDownMenu_AddButton(info, 1);
    -- Tooltip color settings
   local info = {};
    info.text = PS_MTDS;
    info.notClickable = 1;
    info.isTitle = 1;
    UIDropDownMenu_AddButton(info, 1);
    local info = {};
    info.text = PS_NORM;
    if PSvars.ColorMode == "NORMAL" then
      color = true;
    end
    info.checked = color
    info.func = function() PSvars.ColorMode = "NORMAL"; end;
    UIDropDownMenu_AddButton(info, 1);
    local info = {};
    info.text = PS_CLS;
    color = false;
    if PSvars.ColorMode == "CLASS" then
      color = true;
    end
    info.checked = color
    info.func = function() PSvars.ColorMode = "CLASS"; end;
    UIDropDownMenu_AddButton(info, 1);
    local info = {};
    info.text = PS_LCLS;
    color = false;
    if PSvars.ColorMode == "CLASS LEVEL" then
      color = true;
    end
    info.checked = color
    info.func = function() PSvars.ColorMode = "CLASS LEVEL"; end;
    UIDropDownMenu_AddButton(info, 1);
    local info = {};
    info.text = " "
    info.notClickable = 1;
    info.notCheckable = 1;
    UIDropDownMenu_AddButton(info, 1);
  end
  -- Configure colors
  local info = {};
  info.text = PS_OTW;
  color = false;
  info.notCheckable = 1;
  info.checked = color
  info.func = function() PS_OptionsForm:Show(); maptog = 1; end
  UIDropDownMenu_AddButton(info, 1);
end