local PopupModeList =
{
  "UPWARD",
  "DOWNWARD",
  n = 2;
};

local BGList =
{
  "ENABLED",
  "DISABLED",
  n = 2;
};

local SentryList =
{
  "ENABLED",
  "DISABLED",
  n = 2;
};

local NeutralList =
{
  "YES",
  "NO",
  n = 2;
};

local SoundList =
{
  "ENABLED",
  "DISABLED",
  n = 2;
};

local IconList =
{
  "ON",
  "OFF",
  n = 2;
};

local StorageMode =
{
  "ALL",
  "PLAYERS",
  "NPC",
  "NONE",
  n = 4;
};

local AnnounceMode =
{
  "AUTO",
  "SELF",
  "SAY",
  "PARTY",
  "RAID",
  "YELL",
  "LOCALDEFENSE",
  "OFF",
  n = 8;
};

local PingModeList =
{
  "ALWAYS",
  "INSIDE BG",
  "OUTSIDE BG",
  "OFF",
  n = 4;
};
local TooltipModeList =
{
  "NORMAL",
  "CLASS",
  "CLASS LEVEL",
  n = 3;
};

local TimeMode =
{
  "30 SECONDS",
  "1 MINUTE",
  "3 MINUTES",
  "5 MINUTES",
  "OFF",
  n = 5;
};

local ScaleMode =
{
  "LARGE",
  "MEDIUM",
  "SMALL",
  n = 3;
};

local TrackMode =
{
  "ALL",
  "ALL PLAYERS",
  "ENEMIES",
  "ENEMY PLAYERS",
  n = 4;
};

local AddonMode =
{
  "ENABLED",
  "BATTLEGROUNDS",
  "DISABLED",
  n = 3;
};

local DeathMode =
{
  "YES",
  "NO",
  n = 2;
};

local PS_Neutral = "";
local PS_BG = "";
local PS_Announce = "";
local PS_Storage = "";
local PS_IconMode = "";
local PS_BGMode = "";
local PS_PopupMode = "";
local PS_Scalebackup = "";
local PS_PMbackup = "";
local PS_PingMode = "";
local PS_Sentry = "";
local PS_Time = "";
local PS_Addon = "";
local PS_Sound = "";
local PS_scale = "";
local PS_track = "";
local PS_Death = "";

function PS_OptionsForm_OnLoad()

end

function PS_OptionsForm_LoadCombos()

  id = getglobal( "PS_OptionsFormSentryType" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeSentryButtons);
  id = getglobal( "PS_OptionsFormSentryNeut" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeNeutralButtons);
  id = getglobal( "PS_OptionsFormSoundType" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeSoundButtons);
  id = getglobal( "PS_OptionsFormStorageMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeStorageButtons);
  id = getglobal( "PS_OptionsFormAnnounceMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeAnnounceButtons);
  id = getglobal( "PS_OptionsFormMapIconMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeMapIconButtons);
  id = getglobal( "PS_OptionsFormPopupMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakePopupModeButtons);
  id = getglobal( "PS_OptionsFormTimeMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeTimeButtons);
  id = getglobal( "PS_OptionsFormScaleMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeScaleButtons);
  id = getglobal( "PS_OptionsFormAddonMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeAddonButtons);
  id = getglobal( "PS_OptionsFormDeathMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeDeathButtons);
  id = getglobal( "PS_OptionsFormTrackMode" );
  UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeTrackButtons);
  if PSvars.tracker then
    id = getglobal( "PS_OptionsFormBGType" );
    UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeBGButtons);
    id = getglobal( "PS_OptionsFormPingMode" );
    UIDropDownMenu_Initialize( id, PS_OptionsForm_MakePingModeButtons);
    id = getglobal( "PS_OptionsFormTooltipMode" );
    UIDropDownMenu_Initialize( id, PS_OptionsForm_MakeTooltipModeButtons);
  end
end

function PS_OptionsForm_MakeBGButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormBGType" ), BGList, PS_BG, PS_OptionsForm_MakeBGButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormBGType" ), i, 0);
end

function PS_OptionsForm_MakeBGButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormBGType" ), this:GetID(), 0);
  PS_BG = this:GetText();
end
function PS_OptionsForm_MakeSentryButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormSentryType" ), SentryList, PS_Sentry, PS_OptionsForm_MakeSentryButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormSentryType" ), i, 0);
end

function PS_OptionsForm_MakeSentryButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormSentryType" ), this:GetID(), 0);
  PS_Sentry = this:GetText();
end

function PS_OptionsForm_MakeNeutralButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormSentryNeut" ), NeutralList, PS_Neutral, PS_OptionsForm_MakeNeutralButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormSentryNeut" ), i, 0);
end

function PS_OptionsForm_MakeNeutralButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormSentryNeut" ), this:GetID(), 0);
  PS_Neutral = this:GetText();
end

function PS_OptionsForm_MakeSoundButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormSoundType" ), SoundList, PS_Sound, PS_OptionsForm_MakeSoundButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormSoundType" ), i, 0);
end

function PS_OptionsForm_MakeSoundButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormSoundType" ), this:GetID(), 0);
  PS_Sound = this:GetText();
end

function PS_OptionsForm_MakePingModeButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormPingMode" ), PingModeList, PS_PingMode, PS_OptionsForm_MakePingModeButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormPingMode" ), i, 0);
end

function PS_OptionsForm_MakePingModeButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormPingMode" ), this:GetID(), 0);
  PS_PingMode = this:GetText();
end

function PS_OptionsForm_MakePopupModeButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormPopupMode" ), PopupModeList, PS_PopupMode, PS_OptionsForm_MakePopupModeButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormPopupMode" ), i, 0);
end

function PS_OptionsForm_MakePopupModeButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormPopupMode" ), this:GetID(), 0);
  PS_PopupMode = this:GetText();
end

function PS_OptionsForm_MakeTooltipModeButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormTooltipMode" ), TooltipModeList, PS_TooltipMode, PS_OptionsForm_MakeTooltipModeButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormTooltipMode" ), i, 0);
end

function PS_OptionsForm_MakeTooltipModeButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormTooltipMode" ), this:GetID(), 0);
  PS_TooltipMode = this:GetText();
end

function PS_OptionsForm_MakeMapIconButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormMapIconMode" ), IconList, iconmode, PS_OptionsForm_MakeMapIconButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormMapIconMode" ), i, 0);
end

function PS_OptionsForm_MakeMapIconButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormMapIconMode" ), this:GetID(), 0);
  PS_IconMode = this:GetText();
end

function PS_OptionsForm_MakeStorageButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormStorageMode" ), StorageMode, PS_Storage, PS_OptionsForm_MakeStorageButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormStorageMode" ), i, 0);
end

function PS_OptionsForm_MakeStorageButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormStorageMode" ), this:GetID(), 0);
  PS_Storage = this:GetText();
end

function PS_OptionsForm_MakeAnnounceButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormAnnounceMode" ), AnnounceMode, PS_Announce, PS_OptionsForm_MakeAnnounceButtonsClick);
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormAnnounceMode" ), i, 0);
end

function PS_OptionsForm_MakeAnnounceButtonsClick()

  UIDropDownMenu_SetSelectedID(getglobal( "PS_OptionsFormAnnounceMode" ), this:GetID(), 0);
  PS_Announce = this:GetText();
end

function PS_OptionsForm_MakeTimeButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormTimeMode" ), TimeMode, PS_Time, PS_OptionsForm_MakeTimeButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormTimeMode" ), i, 0);
end

function PS_OptionsForm_MakeTimeButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormTimeMode" ), this:GetID(), 0);
  PS_Time = this:GetText();
end

function PS_OptionsForm_MakeScaleButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormScaleMode" ), ScaleMode, PS_Scale, PS_OptionsForm_MakeScaleButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormScaleMode" ), i, 0);
end

function PS_OptionsForm_MakeScaleButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormScaleMode" ), this:GetID(), 0);
  PS_Scalee = this:GetText();
end

function PS_OptionsForm_MakeTrackButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormTrackMode" ), TrackMode, PS_Track, PS_OptionsForm_MakeTrackButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormTrackMode" ), i, 0);
end

function PS_OptionsForm_MakeTrackButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormTrackMode" ), this:GetID(), 0);
  PS_Track = this:GetText();
end

function PS_OptionsForm_MakeAddonButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormAddonMode" ), AddonMode, PS_Addon, PS_OptionsForm_MakeAddonButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormAddonMode" ), i, 0);
end

function PS_OptionsForm_MakeAddonButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormAddonMode" ), this:GetID(), 0);
  PS_Addon = this:GetText();
end

function PS_OptionsForm_MakeDeathButtons()

  local i = PS_OptionsForm_MakeDDButtons( getglobal( "PS_OptionsFormDeathMode" ), DeathMode, PS_Death, PS_OptionsForm_MakeDeathButtonsClick );
  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormDeathMode" ), i, 0);
end

function PS_OptionsForm_MakeDeathButtonsClick()

  UIDropDownMenu_SetSelectedID( getglobal( "PS_OptionsFormDeathMode" ), this:GetID(), 0);
  PS_Death = this:GetText();
end

function PS_OptionsForm_MakeDDButtons( dropdown, list, presel, func )

  local i = 0;
  local info = {};
  local checked = false;
  local preselindex = 1;
  for  i = 1, table.getn(list) do
    info = {};
    info.width = 100;
    info.text = list[i];
    info.value = list[i];
    info.func = func;
    if( presel == list[i] ) then
      preselindex = i;
    end
    UIDropDownMenu_AddButton(info);
  end
  return preselindex;
end

function PS_OptionsForm_InitializeOptions()

  if PSvars.SetTime == 30 then
    PS_Time = "30 SECONDS";
  elseif PSvars.SetTime == 60 then
    PS_Time = "1 MINUTE";
  elseif PSvars.SetTime == 180 then
    PS_Time = "3 MINUTES";
  elseif PSvars.SetTime == 300 then
    PS_Time = "5 MINUTES";
  else
    PS_Time = "OFF";
  end
  PS_Scalebackup = PSvars.scale;
  if PSvars.scale == 1 then
    PS_Scale = "LARGE";
  elseif PSvars.scale == .85 then
    PS_Scale = "MEDIUM";
  else
    PS_Scale = "SMALL";
  end
  if PSvars.Addons == "ON" then
    PS_Addon = "ENABLED";
  elseif PSvars.Addons == "OFF" then
	PS_Addon = "DISABLED";
  else
    PS_Addon = "BATTLEGROUNDS";
  end
  if PSvars.DeathDetect then
    PS_Death = "YES";
  else
	PS_Death = "NO";
  end
  if PSvars.SentryMode then
    PS_Sentry = "ENABLED";
  else
	PS_Sentry = "DISABLED";
  end
  if PSvars.SentryChk then
    PS_Neutral = "YES";
  else
	PS_Neutral = "NO";
  end
  if PSvars.SentrySound then
    PS_Sound = "ENABLED";
  else
	PS_Sound = "DISABLED";
  end
  PS_Track = PSvars.tracking;
  PS_PopupMode = PSvars.PopupMode;
  PS_PMbackup = PSvars.PopupMode;
  if PSvars.BGMode then
    PS_BG = "ENABLED";
  else
    PS_BG = "DISABLED";
  end
  PS_Announce = PSvars.announce;
  PS_Storage = PSvars.storage;
  PS_IconMode = PSvars.MiniIcon;
  if PS_IconMode then
    iconmode = "ON";
  else
    iconmode = "OFF";
  end
  PS_TooltipMode = PSvars.ColorMode;
  PS_PingMode = PSvars.PingMode;
  PS_OptionsForm_LoadCombos();
  PS_OptionsForm_LoadColors();
end

function PS_OptionsForm_LoadColors()

  getglobal("PS_OptionsForm_PlayerEnemyColorColor"):SetTexture( PSvars.EnemyPlayer.r, PSvars.EnemyPlayer.g, PSvars.EnemyPlayer.b );
  getglobal("PS_OptionsForm_NPCEnemyColorColor"):SetTexture( PSvars.EnemyNPC.r, PSvars.EnemyNPC.g, PSvars.EnemyNPC.b );
  getglobal("PS_OptionsForm_PlayerFriendlyColorColor"):SetTexture( PSvars.FriendlyPlayer.r, PSvars.FriendlyPlayer.g, PSvars.FriendlyPlayer.b );
  getglobal("PS_OptionsForm_NPCFriendlyColorColor"):SetTexture( PSvars.FriendlyNPC.r, PSvars.FriendlyNPC.g, PSvars.FriendlyNPC.b );
  getglobal("PS_OptionsForm_UNKPlayerColorColor"):SetTexture( PSvars.UNKPlayer.r, PSvars.UNKPlayer.g, PSvars.UNKPlayer.b );
  getglobal("PS_OptionsForm_UNKNPCColorColor"):SetTexture( PSvars.UNKNPC.r, PSvars.UNKNPC.g, PSvars.UNKNPC.b );
  getglobal("PS_OptionsForm"):SetScale(.75);
end

function PS_OptionsForm_SaveOptions()

  local settime = getglobal("PS_OptionsFormTimeModeText");
  local scale = getglobal("PS_OptionsFormScaleModeText");
  local sentrymode = getglobal("PS_OptionsFormSentryTypeText");
  local neutral = getglobal("PS_OptionsFormSentryNeutText");
  local soundmode = getglobal("PS_OptionsFormSoundTypeText");
  local bgmode 	= getglobal("PS_OptionsFormBGTypeText");
  local storage	= getglobal("PS_OptionsFormStorageModeText");
  local announce = getglobal("PS_OptionsFormAnnounceModeText");
  local iconmode = getglobal("PS_OptionsFormMapIconModeText");
  local colormode = getglobal("PS_OptionsFormTooltipModeText");
  local popupmode = getglobal("PS_OptionsFormPopupModeText");
  local pingmode = getglobal("PS_OptionsFormPingModeText");
  local tracking = getglobal("PS_OptionsFormTrackModeText");
  local addon = getglobal("PS_OptionsFormAddonModeText");
  local death = getglobal("PS_OptionsFormDeathModeText");
  if settime:GetText() == "30 SECONDS" then
    PSvars.SetTime = 30;
  elseif settime:GetText() == "1 MINUTE" then
    PSvars.SetTime = 60;
  elseif settime:GetText() == "3 MINUTES" then
    PSvars.SetTime = 180;
  elseif settime:GetText() == "5 MINUTES" then
    PSvars.SetTime = 300;
  else
    PSvars.SetTime = 9999;
  end
  if scale:GetText() == "LARGE" then
    PSvars.scale = 1;
  elseif scale:GetText() == "MEDIUM" then
    PSvars.scale = .85;
  else
    PSvars.scale = .7;
  end
  if PSvars.scale ~= PS_Scalebackup then
    PS_Clear_Popup();
    PS_addpop = 0;
    PS_dim = 1;
    PS_Process_Tooltip(PS_thelist);
  end
  if sentrymode:GetText() == "ENABLED" then
    PSvars.SentryMode = true;
  else
    PSvars.SentryMode = false;
  end
  if neutral:GetText() == "YES" then
    PSvars.SentryChk = true;
  else
    PSvars.SentryChk = false;
  end
  if soundmode:GetText() == "ENABLED" then
    PSvars.SentrySound = true;
  else
    PSvars.SentrySound = false;
  end
  if death:GetText() == "YES" then
    PSvars.DeathDetect = true;
  else
    PSvars.DeathDetect = false;
  end
  if iconmode:GetText() == "ON" then
    if not PSvars.MiniIcon then
      PS_ToggleMinimapButton();
    end
  else
    if PSvars.MiniIcon then
      PS_ToggleMinimapButton();
    end
  end
  if bgmode:GetText() == "ENABLED" then
    PSvars.BGMode = true;
  else
    PSvars.BGMode = false;
  end
  PSvars.storage = storage:GetText();
  PSvars.announce = announce:GetText();
  if popupmode:GetText() ~= PS_PMbackup then
    PS_Clear_Popup();
    PS_dim = 1;
    PSvars.PopupMode = popupmode:GetText();
    PS_Process_Tooltip( PS_thelist );
  end
  if PSvars.tracker then
    PSvars.ColorMode = colormode:GetText();
    if pingmode:GetText() == "ALWAYS" then
      PSvars.PingMode = "DEFAULT";
    else
      PSvars.PingMode = pingmode:GetText();
    end
  end
  local thelist = PS_thelist;
  if tracking:GetText() == "ALL" then
    PSvars.tracking = "ALL";
  elseif tracking:GetText() == "ALL PLAYERS" then
    PS_Clear_Popup();
    PSvars.tracking = "ALL PLAYERS";
    PS_addpop = 0;
    PS_thelist = "";
    PS_KeepDamage(thelist);
    PS_Process_Tooltip(thelist);
  elseif tracking:GetText() == "ENEMIES" then
    PS_Clear_Popup();
    PSvars.tracking = "ENEMIES";
    PS_addpop = 0;
    PS_thelist = "";
    PS_KeepDamage(thelist);
    PS_Process_Tooltip(thelist);
  else
    PS_Clear_Popup();
    PSvars.tracking = "ENEMY PLAYERS";
    PS_addpop = 0;
    PS_thelist = "";
    PS_KeepDamage(thelist);
    PS_Process_Tooltip(thelist);
  end
  if addon:GetText() == "ENABLED" then
    PSvars.Addons = "ON";
  elseif addon:GetText() == "DISABLED" then
    PSvars.Addons = "OFF";
    PS_Clear_Popup();
    PS_thelist = "";
    PSvars.list = {};
    PS_TraceFrame(PS_DISABLED);
  else
    PSvars.Addons = "BG";
    if not PS_bgmode then
      PS_Clear_Popup();
      PS_thelist = "";
      PSvars.list = {};
    end
  end
  maptog = 0;
  PS_OptionsForm:Hide();
end

function PS_DisplayColorPicker( colorvar, colorfunc, cancelfunc )

  PlaySound("igMainMenuOptionCheckBoxOn");
  ColorPickerFrame.func = colorfunc;
  ColorPickerFrame.cancelFunc = cancelfunc;
  ColorPickerFrame:SetColorRGB( colorvar.r, colorvar.g, colorvar.b );
  ColorPickerFrame.previousValues = { colorvar.r, colorvar.g, colorvar.b };
  ShowUIPanel(ColorPickerFrame);
end

function PSvars_EnemyPlayer_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_PlayerEnemyColorColor"):SetTexture( r, g, b );
  PSvars.EnemyPlayer.r = r;
  PSvars.EnemyPlayer.g = g;
  PSvars.EnemyPlayer.b = b;
end


function PSvars_EnemyPlayer_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_PlayerEnemyColorColor"):SetTexture( r, g, b );
  PSvars.EnemyPlayer.r = r;
  PSvars.EnemyPlayer.g = g;
  PSvars.EnemyPlayer.b = b;
end

function PSvars_EnemyNPC_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_NPCEnemyColorColor"):SetTexture( r, g, b );
  PSvars.EnemyNPC.r = r;
  PSvars.EnemyNPC.g = g;
  PSvars.EnemyNPC.b = b;
end


function PSvars_EnemyNPC_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_NPCEnemyColorColor"):SetTexture( r, g, b );
  PSvars.EnemyNPC.r = r;
  PSvars.EnemyNPC.g = g;
  PSvars.EnemyNPC.b = b;
end

function PSvars_FriendlyPlayer_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_PlayerFriendlyColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyPlayer.r = r;
  PSvars.FriendlyPlayer.g = g;
  PSvars.FriendlyPlayer.b = b;
end


function PSvars_FriendlyPlayer_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_PlayerFriendlyColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyPlayer.r = r;
  PSvars.FriendlyPlayer.g = g;
  PSvars.FriendlyPlayer.b = b;
end

function PSvars_FriendlyNPC_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_NPCFriendlyColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyNPC.r = r;
  PSvars.FriendlyNPC.g = g;
  PSvars.FriendlyNPC.b = b;
end


function PSvars_FriendlyNPC_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_NPCFriendlyColorColor"):SetTexture( r, g, b );
  PSvars.FriendlyNPC.r = r;
  PSvars.FriendlyNPC.g = g;
  PSvars.FriendlyNPC.b = b;
end

function PSvars_UNKPlayer_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_UNKPlayerColorColor"):SetTexture( r, g, b );
  PSvars.UNKPlayer.r = r;
  PSvars.UNKPlayer.g = g;
  PSvars.UNKPlayer.b = b;
end


function PSvars_UNKPlayer_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_UNKPlayerColorColor"):SetTexture( r, g, b );
  PSvars.UNKPlayer.r = r;
  PSvars.UNKPlayer.g = g;
  PSvars.UNKPlayer.b = b;
end

function PSvars_UNKNPC_Change()

  local r,g,b = ColorPickerFrame:GetColorRGB();
  getglobal("PS_OptionsForm_UNKNPCColorColor"):SetTexture( r, g, b );
  PSvars.UNKNPC.r = r;
  PSvars.UNKNPC.g = g;
  PSvars.UNKNPC.b = b;
end


function PSvars_UNKNPC_Cancel( prev )

  local r,g,b = unpack( prev );
  getglobal("PS_OptionsForm_UNKNPCColorColor"):SetTexture( r, g, b );
  PSvars.UNKNPC.r = r;
  PSvars.UNKNPC.g = g;
  PSvars.UNKNPC.b = b;
end